>From 86c7b8ff8cb4acf1a9e5eee0c6534c03e1264e70 Mon Sep 17 00:00:00 2001
From: Arnaud <arnaud.champion@devatom.fr>
Date: Sat, 30 Oct 2010 16:30:46 +0200
Subject: [PATCH] Add / cleaning comments. New sample virConnectSetErrorFunc. Correct virDomainInfo marshaling

---
 Connect.cs                                         |    3 +
 Domain.cs                                          |    5 +-
 Errors.cs                                          |   16 +-
 Event.cs                                           |    3 +
 Interface.cs                                       |    3 +
 Library.cs                                         |    3 +
 MarshalHelper.cs                                   |   22 +-
 NativeFunctions.cs                                 |   11 +-
 Network.cs                                         |    3 +
 Node.cs                                            |    3 +
 Secret.cs                                          |    3 +
 StoragePool.cs                                     |    5 +-
 StorageVol.cs                                      |  161 +++------
 Stream.cs                                          |    3 +
 Types.cs                                           |   27 +-
 .../virConnectSetErrorFunc/AssemblyInfo.cs         |   27 ++
 .../MonoDevelop/virConnectSetErrorFunc/Main.cs     |   17 +
 .../virConnectSetErrorFunc/MainWindow.cs           |   79 ++++
 .../virConnectSetErrorFunc/gtk-gui/MainWindow.cs   |  260 +++++++++++++
 .../virConnectSetErrorFunc/gtk-gui/generated.cs    |   29 ++
 .../virConnectSetErrorFunc/gtk-gui/gui.stetic      |  381 ++++++++++++++++++++
 .../virConnectSetErrorFunc.csproj                  |    1 +
 .../virEventRegisterImpl/gtk-gui/MainWindow.cs     |    1 -
 .../virEventRegisterImpl.csproj                    |   62 ++++-
 .../virConnectSetErrorFunc/Form1.Designer.cs       |  237 ++++++++++++
 .../VisualStudio/virConnectSetErrorFunc/Form1.cs   |   50 +++
 .../VisualStudio/virConnectSetErrorFunc/Form1.resx |  120 ++++++
 .../VisualStudio/virConnectSetErrorFunc/Program.cs |   21 ++
 .../Properties/AssemblyInfo.cs                     |   36 ++
 .../Properties/Resources.Designer.cs               |   71 ++++
 .../Properties/Resources.resx                      |  117 ++++++
 .../Properties/Settings.Designer.cs                |   30 ++
 .../Properties/Settings.settings                   |    7 +
 .../virConnectSetErrorFunc.csproj                  |   93 +++++
 projects/MonoDevelop/LibvirtBindings.sln           |    9 +-
 projects/VisualStudio/LibvirtBindings.csproj       |    2 +
 projects/VisualStudio/LibvirtBindings.sln          |   13 +
 37 files changed, 1791 insertions(+), 143 deletions(-)
 create mode 100644 examples/MonoDevelop/virConnectSetErrorFunc/AssemblyInfo.cs
 create mode 100644 examples/MonoDevelop/virConnectSetErrorFunc/Main.cs
 create mode 100644 examples/MonoDevelop/virConnectSetErrorFunc/MainWindow.cs
 create mode 100644 examples/MonoDevelop/virConnectSetErrorFunc/gtk-gui/MainWindow.cs
 create mode 100644 examples/MonoDevelop/virConnectSetErrorFunc/gtk-gui/generated.cs
 create mode 100644 examples/MonoDevelop/virConnectSetErrorFunc/gtk-gui/gui.stetic
 create mode 100644 examples/MonoDevelop/virConnectSetErrorFunc/virConnectSetErrorFunc.csproj
 rewrite examples/MonoDevelop/virEventRegisterImpl/virEventRegisterImpl.csproj (100%)
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Form1.Designer.cs
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Form1.cs
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Form1.resx
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Program.cs
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Properties/AssemblyInfo.cs
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Properties/Resources.Designer.cs
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Properties/Resources.resx
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Properties/Settings.Designer.cs
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/Properties/Settings.settings
 create mode 100644 examples/VisualStudio/virConnectSetErrorFunc/virConnectSetErrorFunc.csproj

diff --git a/Connect.cs b/Connect.cs
index 5530c32..516bc5a 100644
--- a/Connect.cs
+++ b/Connect.cs
@@ -11,6 +11,9 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Connect class expose all connection related methods
+    /// </summary>
     public class Connect
     {
         private const int MaxStringLength = 1024;
diff --git a/Domain.cs b/Domain.cs
index 6d32300..4f1aba2 100644
--- a/Domain.cs
+++ b/Domain.cs
@@ -11,6 +11,9 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Domain class expose the domains related methods
+    /// </summary>
     public class Domain
     {
         /// <summary>
@@ -314,7 +317,7 @@ namespace Libvirt
         /// Path to the interface.
         /// </param>
         /// <param name="stats">
-        /// A <see cref="virDomainInterfaceStatsStruct"/>network interface stats (returned).
+        /// A <see cref="DomainInterfaceStatsStruct"/>network interface stats (returned).
         /// </param>
         /// <param name="size">
         /// Size of stats structure.
diff --git a/Errors.cs b/Errors.cs
index 921d067..ae8047f 100644
--- a/Errors.cs
+++ b/Errors.cs
@@ -38,7 +38,7 @@ namespace Libvirt
         /// A <see cref="IntPtr"/>pointer to the user data provided in the handler callback.
         /// </param>
         /// <param name="handler">
-        /// A <see cref="virErrorFunc"/>function to get called in case of error or NULL
+        /// A <see cref="ErrorFunc"/>function to get called in case of error or NULL
         /// </param>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virConnSetErrorFunc")]
         public static extern void ConnSetErrorFunc(IntPtr conn, IntPtr userData, [MarshalAs(UnmanagedType.FunctionPtr)] ErrorFunc handler);
@@ -49,7 +49,7 @@ namespace Libvirt
         /// One will need to free the result with virResetError().
         /// </summary>
         /// <param name="to">
-        /// A <see cref="virError"/> target to receive the copy.
+        /// A <see cref="Error"/> target to receive the copy.
         /// </param>
         /// <returns>
         /// 0 if no error was found and the error code otherwise and -1 in case of parameter error.
@@ -61,7 +61,7 @@ namespace Libvirt
         /// Default routine reporting an error to stderr.
         /// </summary>
         /// <param name="err">
-        /// A <see cref="virError"/> pointer to the error.
+        /// A <see cref="Error"/> pointer to the error.
         /// </param>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virDefaultErrorFunc")]
         public static extern void DefaultErrorFunc([In] Error err);
@@ -70,7 +70,7 @@ namespace Libvirt
         /// Resets and frees the given error.
         /// </summary>
         /// <param name="err">
-        /// A <see cref="virError"/> error to free.
+        /// A <see cref="Error"/> error to free.
         /// </param>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virFreeError")]
         public static extern void FreeError(Error err); // Does not work, anybody know why?
@@ -83,13 +83,13 @@ namespace Libvirt
         /// A pointer to the last error or NULL if none occurred.
         /// </returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virGetLastError")]
-        public static extern int GetLastError();
+        public static extern Error GetLastError();
 
         /// <summary>
         /// Reset the error being pointed to.
         /// </summary>
         /// <param name="err">
-        /// A <see cref="virError"/> pointer to the to clean up.
+        /// A <see cref="Error"/> pointer to the to clean up.
         /// </param>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virResetError")]
         public static extern void ResetError(Error err);
@@ -105,7 +105,7 @@ namespace Libvirt
         /// Save the last error into a new error object.
         /// </summary>
         /// <returns>
-        /// A <see cref="virError"/> pointer to the copied error or NULL if allocation failed. 
+        /// A <see cref="Error"/> pointer to the copied error or NULL if allocation failed. 
         /// It is the caller's responsibility to free the error with virFreeError().
         /// </returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virSaveLastError")]
@@ -119,7 +119,7 @@ namespace Libvirt
         /// A <see cref="IntPtr"/>pointer to the user data provided in the handler callback.
         /// </param>
         /// <param name="handler">
-        /// A <see cref="virErrorFunc"/>function to get called in case of error or NULL.
+        /// A <see cref="ErrorFunc"/>function to get called in case of error or NULL.
         /// </param>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virSetErrorFunc")]
         public static extern void SetErrorFunc(IntPtr userData, [MarshalAs(UnmanagedType.FunctionPtr)] ErrorFunc handler);
diff --git a/Event.cs b/Event.cs
index 1540d70..c6a0673 100644
--- a/Event.cs
+++ b/Event.cs
@@ -10,6 +10,9 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Event class expose all the event related methods
+    /// </summary>
     public class Event
     {
         ///<summary>
diff --git a/Interface.cs b/Interface.cs
index 51d1f76..9434b2b 100644
--- a/Interface.cs
+++ b/Interface.cs
@@ -8,6 +8,9 @@
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Interface class expose all interface related methods
+    /// </summary>
     public class Interface
     {
         // TODO virInterfaceCreate
diff --git a/Library.cs b/Library.cs
index 03f2038..1a0a3a3 100644
--- a/Library.cs
+++ b/Library.cs
@@ -10,6 +10,9 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Library class expose all libvirt library related methods
+    /// </summary>
     public class Library
     {
         /// <summary>
diff --git a/MarshalHelper.cs b/MarshalHelper.cs
index fc93893..6d4b351 100644
--- a/MarshalHelper.cs
+++ b/MarshalHelper.cs
@@ -11,8 +11,17 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The MarshalHelper class provide some methods that simplify marshaling
+    /// </summary>
     public class MarshalHelper
     {
+        /// <summary>
+        /// Convert an Inttr to a string array
+        /// </summary>
+        /// <param name="stringPtr">The pointer to the first element of the array</param>
+        /// <param name="stringCount">The number of elements in the array</param>
+        /// <returns>The string array</returns>
         public static string[] ptrToStringArray(IntPtr stringPtr, int stringCount)
         {
             string[] members = new string[stringCount];
@@ -23,13 +32,22 @@ namespace Libvirt
             }
             return members;
         }
-
+        /// <summary>
+        /// Convert an IntPtr to a string
+        /// </summary>
+        /// <param name="stringPtr">The pointer</param>
+        /// <returns>The string</returns>
         public static string ptrToString(IntPtr stringPtr)
         {
             IntPtr s = Marshal.ReadIntPtr(stringPtr, IntPtr.Size);
             return Marshal.PtrToStringAnsi(s);
         }
-
+        /// <summary>
+        /// Shift a pointer by offset (32 or 64 bits pointer)
+        /// </summary>
+        /// <param name="src">The pointer</param>
+        /// <param name="offset">The offset in bytes</param>
+        /// <returns>the shifted pointer</returns>
         public static IntPtr IntPtrOffset(IntPtr src, int offset)
         {
             switch (IntPtr.Size)
diff --git a/NativeFunctions.cs b/NativeFunctions.cs
index 25d7532..5805d88 100644
--- a/NativeFunctions.cs
+++ b/NativeFunctions.cs
@@ -7,16 +7,21 @@
  */
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
 using System.Runtime.InteropServices;
-using System.Text;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The class expose some useful native functions
+    /// </summary>
     public class NativeFunctions
     {
         // TODO : this is atemporary workaround for virConnectOpenAuth callback, this should be removed
+        /// <summary>
+        /// duplicate a string. The strdup function shall return a pointer to a new string, which is a duplicate of the string pointed to by s1.
+        /// </summary>
+        /// <param name="strSource">Pointer to the string that should be duplicated</param>
+        /// <returns>a pointer to a new string on success. Otherwise, it shall return a null pointer</returns>
         [DllImport("msvcrt.dll", EntryPoint = "_strdup", CallingConvention = CallingConvention.Cdecl)]
         public static extern IntPtr StrDup(IntPtr strSource);
     }
diff --git a/Network.cs b/Network.cs
index 9c4bdff..9164637 100644
--- a/Network.cs
+++ b/Network.cs
@@ -11,6 +11,9 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Network clas expose all libvirt network related functions
+    /// </summary>
     public class Network
     {
         /// <summary>
diff --git a/Node.cs b/Node.cs
index e4389f3..fb4c3af 100644
--- a/Node.cs
+++ b/Node.cs
@@ -11,6 +11,9 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Node class expose all libvirt node related functions
+    /// </summary>
     public class Node
     {
 		private const int MaxStringLength = 1024;
diff --git a/Secret.cs b/Secret.cs
index 34f38a0..885a52e 100644
--- a/Secret.cs
+++ b/Secret.cs
@@ -8,6 +8,9 @@
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Secret class expose all libvirt secret related functions
+    /// </summary>
     public class Secret
     {
         // TODO virSecretDefineXML
diff --git a/StoragePool.cs b/StoragePool.cs
index ec0d635..504f9aa 100644
--- a/StoragePool.cs
+++ b/StoragePool.cs
@@ -11,6 +11,9 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The StoragePool class expose all libvirt storage pool related functions
+    /// </summary>
     public class StoragePool
     {
 		private const int MaxStringLength = 1024;
@@ -90,7 +93,7 @@ namespace Libvirt
         /// A <see cref="IntPtr"/>pointer to storage pool.
         /// </param>
         /// <param name="flags">
-        /// A <see cref="virStoragePoolDeleteFlags"/>flags for obliteration process.
+        /// A <see cref="StoragePoolDeleteFlags"/>flags for obliteration process.
         /// </param>
         /// <returns>
         /// 0 on success, or -1 if it could not be obliterate.
diff --git a/StorageVol.cs b/StorageVol.cs
index 9730172..6c44073 100644
--- a/StorageVol.cs
+++ b/StorageVol.cs
@@ -11,43 +11,30 @@ using System.Runtime.InteropServices;
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The StorageVol class expose all libvirt storage volume related functions
+    /// </summary>
     public class StorageVol
     {
 
         /// <summary>
         /// Create a storage volume within a pool based on an XML description. Not all pools support creation of volumes.
         /// </summary>
-        /// <param name="pool">
-        /// A <see cref="IntPtr"/>pointer to storage pool.
-        /// </param>
-        /// <param name="xmldesc">
-        /// A <see cref="System.String"/>description of volume to create.
-        /// </param>
-        /// <param name="flags">
-        /// A <see cref="System.UInt32"/>flags for creation (unused, pass 0).
-        /// </param>
-        /// <returns>
-        /// The storage volume, or NULL on error.
-        /// </returns>
+        /// <param name="pool">A <see cref="IntPtr"/>pointer to storage pool.</param>
+        /// <param name="xmldesc">A <see cref="System.String"/>description of volume to create.</param>
+        /// <param name="flags">A <see cref="System.UInt32"/>flags for creation (unused, pass 0).</param>
+        /// <returns>The storage volume, or NULL on error.</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolCreateXML")]
         public static extern IntPtr CreateXML(IntPtr pool, string xmldesc, uint flags);
 
         /// <summary>
-        /// Create a storage volume in the parent pool, using the 'clonevol' volume as input. 
+        /// Create a storage volume in the parent pool, using the 'clonevol' volume as input.
         /// Information for the new volume (name, perms) are passed via a typical volume XML description.
         /// </summary>
-        /// <param name="pool">
-        /// A <see cref="IntPtr"/>pointer to parent pool for the new volume.
-        /// </param>
-        /// <param name="xmldesc">
-        /// A <see cref="System.String"/>description of volume to create.
-        /// </param>
-        /// <param name="clonevol">
-        /// A <see cref="IntPtr"/>storage volume to use as input.
-        /// </param>
-        /// <param name="flags">
-        /// A <see cref="System.UInt32"/>flags for creation (unused, pass 0).
-        /// </param>
+        /// <param name="pool">A <see cref="IntPtr"/>pointer to parent pool for the new volume.</param>
+        /// <param name="xmldesc">A <see cref="System.String"/>description of volume to create.</param>
+        /// <param name="clonevol">A <see cref="IntPtr"/>storage volume to use as input.</param>
+        /// <param name="flags">A <see cref="System.UInt32"/>flags for creation (unused, pass 0).</param>
         /// <returns>
         /// A <see cref="IntPtr"/>the storage volume, or NULL on error.
         /// </returns>
@@ -57,70 +44,46 @@ namespace Libvirt
         /// <summary>
         /// Delete the storage volume from the pool.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>pointer to storage volume.
-        /// </param>
-        /// <param name="flags">
-        /// A <see cref="System.UInt32"/>future flags, use 0 for now.
-        /// </param>
-        /// <returns>
-        /// 0 on success, or -1 on error.
-        /// </returns>
+        /// <param name="vol">A <see cref="IntPtr"/>pointer to storage volume.</param>
+        /// <param name="flags">A <see cref="System.UInt32"/>future flags, use 0 for now.</param>
+        /// <returns>0 on success, or -1 on error.</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolDelete")]
         public static extern int Delete(IntPtr vol, uint flags);
 
         /// <summary>
         /// Release the storage volume handle. The underlying storage volume continues to exist.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>pointer to storage volume.
-        /// </param>
-        /// <returns>
-        /// 0 on success, or -1 on error.
-        /// </returns>
+        /// <param name="vol">A <see cref="IntPtr"/>pointer to storage volume.</param>
+        /// <returns>0 on success, or -1 on error.</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolFree")]
         public static extern int Free(IntPtr vol);
 
         /// <summary>
-        /// Provides the connection pointer associated with a storage volume. 
-        /// The reference counter on the connection is not increased by this call. 
-        /// WARNING: When writing libvirt bindings in other languages, do not use this function. 
+        /// Provides the connection pointer associated with a storage volume.
+        /// The reference counter on the connection is not increased by this call.
+        /// WARNING: When writing libvirt bindings in other languages, do not use this function.
         /// Instead, store the connection and the volume object together.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>
-        /// </param>
-        /// <returns>
-        /// A <see cref="IntPtr"/>
-        /// </returns>
+        /// <param name="vol">A <see cref="IntPtr"/> pointer to the storage volume</param>
+        /// <returns>A <see cref="IntPtr"/>A Pointer to the connect that hold the storage volume</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolGetConnect")]
         public static extern IntPtr GetConnect(IntPtr vol);
 
         /// <summary>
         /// Fetches volatile information about the storage volume such as its current allocation.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>pointer to storage volume.
-        /// </param>
-        /// <param name="info">
-        /// A <see cref="virStorageVolInfo"/>pointer at which to store info.
-        /// </param>
-        /// <returns>
-        /// 0 on success, or -1 on failure.
-        /// </returns>
+        /// <param name="vol">A <see cref="IntPtr"/>pointer to storage volume.</param>
+        /// <param name="info">A <see cref="StorageVolInfo"/>pointer at which to store info.</param>
+        /// <returns>0 on success, or -1 on failure.</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolGetInfo")]
         public static extern int GetInfo(IntPtr vol, ref StorageVolInfo info);
 
         /// <summary>
-        /// Fetch the storage volume key. 
+        /// Fetch the storage volume key.
         /// This is globally unique, so the same volume will have the same key no matter what host it is accessed from
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>pointer to storage volume.
-        /// </param>
-        /// <returns>
-        /// The volume key, or NULL on error.
-        /// </returns>
+        /// <param name="vol">A <see cref="IntPtr"/>pointer to storage volume.</param>
+        /// <returns>The volume key, or NULL on error.</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolGetKey")]
         [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string GetKey(IntPtr vol);
@@ -128,25 +91,19 @@ namespace Libvirt
         /// <summary>
         /// Fetch the storage volume name. This is unique within the scope of a pool.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>pointer to storage volume.
-        /// </param>
-        /// <returns>
-        /// The volume name, or NULL on error.
-        /// </returns>
+        /// <param name="vol">A <see cref="IntPtr"/>pointer to storage volume.</param>
+        /// <returns>The volume name, or NULL on error.</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolGetName")]
         [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string GetName(IntPtr vol);
 
         /// <summary>
-        /// Fetch the storage volume path. 
-        /// Depending on the pool configuration this is either persistent across hosts, 
-        /// or dynamically assigned at pool startup. 
+        /// Fetch the storage volume path.
+        /// Depending on the pool configuration this is either persistent across hosts,
+        /// or dynamically assigned at pool startup.
         /// Consult pool documentation for information on getting the persistent naming.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>pointer to storage volume.
-        /// </param>
+        /// <param name="vol">A <see cref="IntPtr"/>pointer to storage volume.</param>
         /// <returns>
         /// The storage volume path, or NULL on error.
         /// </returns>
@@ -157,15 +114,9 @@ namespace Libvirt
         /// <summary>
         /// Fetch an XML document describing all aspects of the storage volume.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>pointer to storage volume.
-        /// </param>
-        /// <param name="flags">
-        /// A <see cref="System.UInt32"/>flags for XML generation (unused, pass 0).
-        /// </param>
-        /// <returns>
-        /// The XML document, or NULL on error.
-        /// </returns>
+        /// <param name="vol">A <see cref="IntPtr"/>pointer to storage volume.</param>
+        /// <param name="flags">A <see cref="System.UInt32"/>flags for XML generation (unused, pass 0).</param>
+        /// <returns>The XML document, or NULL on error.</returns>
         [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virStorageVolGetXMLDesc")]
         [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string GetXMLDesc(IntPtr vol, uint flags);
@@ -173,12 +124,8 @@ namespace Libvirt
         /// <summary>
         /// Fetch a pointer to a storage volume based on its globally unique key.
         /// </summary>
-        /// <param name="conn">
-        /// A <see cref="IntPtr"/>pointer to hypervisor connection.
-        /// </param>
-        /// <param name="key">
-        /// A <see cref="System.String"/>globally unique key.
-        /// </param>
+        /// <param name="conn">A <see cref="IntPtr"/>pointer to hypervisor connection.</param>
+        /// <param name="key">A <see cref="System.String"/>globally unique key.</param>
         /// <returns>
         /// A <see cref="IntPtr"/>storage volume, or NULL if not found / error.
         /// </returns>
@@ -188,12 +135,8 @@ namespace Libvirt
         /// <summary>
         /// Fetch a pointer to a storage volume based on its name within a pool.
         /// </summary>
-        /// <param name="pool">
-        /// A <see cref="IntPtr"/>pointer to storage pool.
-        /// </param>
-        /// <param name="name">
-        /// A <see cref="System.String"/>name of storage volume.
-        /// </param>
+        /// <param name="pool">A <see cref="IntPtr"/>pointer to storage pool.</param>
+        /// <param name="name">A <see cref="System.String"/>name of storage volume.</param>
         /// <returns>
         /// A <see cref="IntPtr"/>storage volume, or NULL if not found / error.
         /// </returns>
@@ -203,12 +146,8 @@ namespace Libvirt
         /// <summary>
         /// Fetch a pointer to a storage volume based on its locally (host) unique path.
         /// </summary>
-        /// <param name="conn">
-        /// A <see cref="IntPtr"/>pointer to hypervisor connection.
-        /// </param>
-        /// <param name="path">
-        /// A <see cref="System.String"/>locally unique path.
-        /// </param>
+        /// <param name="conn">A <see cref="IntPtr"/>pointer to hypervisor connection.</param>
+        /// <param name="path">A <see cref="System.String"/>locally unique path.</param>
         /// <returns>
         /// A <see cref="IntPtr"/>storage volume, or NULL if not found / error.
         /// </returns>
@@ -216,16 +155,14 @@ namespace Libvirt
         public static extern IntPtr LookupByPath(IntPtr conn, string path);
 
         /// <summary>
-        /// Increment the reference count on the vol. For each additional call to this method, 
-        /// there shall be a corresponding call to virStorageVolFree to release the reference count, 
-        /// once the caller no longer needs the reference to this object. 
-        /// This method is typically useful for applications where multiple threads are using a connection, 
-        /// and it is required that the connection remain open until all threads have finished using it. ie, 
+        /// Increment the reference count on the vol. For each additional call to this method,
+        /// there shall be a corresponding call to virStorageVolFree to release the reference count,
+        /// once the caller no longer needs the reference to this object.
+        /// This method is typically useful for applications where multiple threads are using a connection,
+        /// and it is required that the connection remain open until all threads have finished using it. ie,
         /// each new thread using a vol would increment the reference count.
         /// </summary>
-        /// <param name="vol">
-        /// A <see cref="IntPtr"/>the vol to hold a reference on.
-        /// </param>
+        /// <param name="vol">A <see cref="IntPtr"/>the vol to hold a reference on.</param>
         /// <returns>
         /// A <see cref="System.Int32"/>0 in case of success, -1 in case of failure.
         /// </returns>
diff --git a/Stream.cs b/Stream.cs
index 3b24543..bef3719 100644
--- a/Stream.cs
+++ b/Stream.cs
@@ -8,6 +8,9 @@
 
 namespace Libvirt
 {
+    /// <summary>
+    /// The Stream class expose all libvirt stream related functions
+    /// </summary>
     public class Stream
     {
         // TODO virStreamAbort
